package assignment_matrix_layouter;

import java.util.*;

import util.*;

/**
 * Diese Klasse zeichnet Verbindungen
 * zwischen verschiedenen Zeilen in ASCII-Art.
 * 
 * Dadurch lassen sich untereinander referenzierte 
 * Zeilen (Positionen) einer Tabelle bersichtlich
 * darstellen.
 * 
 * @author Heiner Kcker
 */
public class AssignmentMatrixLayouter
{
    /**
     * Test.
     * 
     * @param args
     */
    public static void main(String[] args)
    {
        final AssignmentMatrixConnectionStyle starStyle =
            new AssignmentMatrixConnectionStyle( "*****", "*=" );
        
        final AssignmentMatrixConnectionStyle equalChrStyle =
            new AssignmentMatrixConnectionStyle( "=+|+=", "o=" );
        
        if ( true )
        {
            final AssignmentMatrix matrix = new AssignmentMatrix();
            
            final AssignmentMatrixNode node0 = 
                new AssignmentMatrixNode(
                        "Node0",
                        1 );
            
            matrix.add( node0 );

            final AssignmentMatrixNode node1 = 
                new AssignmentMatrixNode(
                        "Node1",
                        3 );

            matrix.add( node1 );

            final AssignmentMatrixNode node2 = 
                new AssignmentMatrixNode(
                        "Node2",
                        5 );

            matrix.add( node2 );

            final AssignmentMatrixNode node3 = 
                new AssignmentMatrixNode(
                        "Node3",
                        7 );

            matrix.add( node3 );

            final AssignmentMatrixNode node4 = 
                new AssignmentMatrixNode(
                        "Node4",
                        9 );

            matrix.add( node4 );

            final AssignmentMatrixNode node5 = 
                new AssignmentMatrixNode(
                        "Node5",
                        11 );

            matrix.add( node5 );

            //--------------------------------
            
            node5.addReferenceTo( 
                    node0 );

            node1.addReferenceTo( 
                    node2 );

            node2.addReferenceTo( 
                    node1,
                    equalChrStyle );

            node3.addReferenceTo( 
                    node4,
                    starStyle );

            node4.addReferenceTo( 
                    node3 );
            
            //--------------------------------
            
            System.out.println(
                    createLayout(
                            matrix,
                            " ",
                            true ) );
            
            System.out.println();
            
            //--------------------------------
        }

        /*
         * Vereinfachte Varaiante zum Anlegen der Verknpfungs-Matrix
         */
        if ( true )
        {
            System.out.println(
                    createLayout(
                            new Object[][]{ 
                                    { "Node 0" , new String[]{ "Node 1" , "Node 8" } },
                                    { "Node 1" , new String[]{} },
                                    { "Node 2" , new String[]{ "Node 3" } },
                                    { "Node 3" , new String[]{ "Node 2" } },
                                    { "Node 4" , new String[]{ "Node 5" } },
                                    { "Node 5" , new String[]{} },
                                    { "Node 6" , new String[]{ "Node 7" } },
                                    { "Node 7" , new String[]{ "Node 5" } },
                                    { "Node 8" , new String[]{ "Node 0" , "Node 9" } },
                                    { "Node 9" , new String[]{ "Node 0" } }
                            },
                            1,
                            2,
                            " ",
                            true ) );
        }
        if ( true )
        {
            System.out.println(
                    createLayout(
                            new Object[][]{ 
                                    { "Node 0" , new String[]{ "Node 1" } },
                                    { "Node 1" , new String[]{ "Node 0" } }
//                                    { "Node 2" , new String[]{ "Node 3" } },
//                                    { "Node 3" , new String[]{ "Node 2" } },
//                                    { "Node 4" , new String[]{ "Node 5" } },
//                                    { "Node 5" , new String[]{} },
//                                    { "Node 6" , new String[]{ "Node 7" } },
//                                    { "Node 7" , new String[]{ "Node 5" } },
//                                    { "Node 8" , new String[]{ "Node 9" } },
//                                    { "Node 9" , new String[]{ "Node 0" } }
                            },
                            1,
                            2,
                            " ",
                            true ) );
        }
        if ( true )
        {
            System.out.println(
                    createLayout(
                            new String[]{ 
                                    "Node 0:Node 1,Node 9",
                                    "Node 1",
                                    "Node 2:Node 3",
                                    "Node 3:Node 2",
                                    "Node 4:Node 5",
                                    "Node 5:Node 4",
                                    "Node 6:Node 7",
                                    "Node 7:Node 5",
                                    "Node 8:Node 0,Node 9",
                                    "Node 9:Node 0"
                            },
                            1,
                            2,
                            " ",
                            true ) );
        }
        if ( true )
        {
            System.out.println(
                    createLayout(
                            new String[]{ 
                                    "3049600117578:3049600117579",
                                    "3049600117579:3049600117578",
                                    "3129600096889:3129600096890",
                                    "3129600096890:3129600096889",
                                    "4129600104746:5039600217361",
                                    "4129600104747",
                                    "5039600217362",
                                    "5039600217361:4129600104746",
                                    "5039600217363",
                                    "5039600217364:5085000007916",
                                    "5085000007916:5039600217364",
                                    "5085000007915:5085000007914",
                                    "5085000007914:5085000007915",
                                    "5081800695261",
                                    "5085000007918",
                                    "5085000007917",
                                    "6051800417773:7010000017770",
                                    "6051800716141",
                                    "6051800716142",
                                    "6061800583088",
                                    "6061800583089",
                                    "6066300006951",
                                    "6066300006950:6121700064058",
                                    "6066300006949:7010000012393",
                                    "6066300006948:6121700064059",
                                    "6061800586717:6121801409430",
                                    "6121700064059:6066300006948",
                                    "6121700064058:6066300006950",
                                    "6121801409431",
                                    "6121801409430:6061800586717",
                                    "7010000012393:6066300006949",
                                    "7010000017770:6051800417773",
                                    "7011800567762",
                                    "7010000017771"
                            },
                            1,
                            2,
                            " ",
                            true ) );
        }
    }
    
    /**
     * Mindest-Platz in Anzahl Zeichen 
     * fr eine vertikaler Linie.
     */
    public static final int LINE_SPACE = 3;
    
    /**
     * Vereinfachtes Layout mit der
     * bergabe der Struktur als String-Array,
     * wobei je Eintrag der Knoten-Name mit einem
     * Doppelpunkt von der kommaseparierten Liste
     * der referenzierten Knoten getrent wird.
     * 
     * @param pObjObjArr
     * @param pString
     * @return
     */
    public static String createLayout(
            final String[] pStrArr )
    {
        return createLayout(
                pStrArr, 
                1,
                2,
                " ",
                true );
    }
    /**
     * Vereinfachtes Layout mit der
     * bergabe der Struktur als String-Array,
     * wobei je Eintrag der Knoten-Name mit einem
     * Doppelpunkt von der kommaseparierten Liste
     * der referenzierten Knoten getrent wird.
     * 
     * @param pObjObjArr
     * @param pString
     * @return
     */
    public static String createLayout(
            final String[] pStrArr, 
            final int pStartLineOffset,
            final int pLineOffset,
            final String pRightBorderStr,
            final boolean pJoinBidirectionalLinks )
    {
        final ArrayList nodeList = new ArrayList( pStrArr.length );
        
        for (int i = 0; i < pStrArr.length; i++)
        {
            final String nodeLineStr = pStrArr[i];
            // Node-Name mit ':' getrennt
            final String[] nodeLineTokStrArr = StringUtil.tokenize(nodeLineStr, ":", false, false);
            final String nodeName = nodeLineTokStrArr[ 0 ].trim();
            final String[] refNodeNameArr;
            if ( nodeLineTokStrArr.length > 1 )
            {
                // referenzierte Node-Namen mit ',' getrennt
                refNodeNameArr = 
                    StringUtil.arrTrim(
                            StringUtil.tokenize(nodeLineTokStrArr[ 1 ], ",", false, false ) );
            }
            else
            {
                refNodeNameArr = new String[ 0 ];
            }
            final Object[] nodeObjArr = new Object[]{ nodeName , refNodeNameArr };
            nodeList.add( nodeObjArr );
        }
        
        final Object[] nodeObjObjArr = nodeList.toArray();
        return createLayout(
                nodeObjObjArr, 
                pStartLineOffset, 
                pLineOffset, 
                pRightBorderStr, 
                pJoinBidirectionalLinks);
        
        
    }
    /**
     * Vereinfachtes Layout mit der
     * bergabe der Struktur als Object-Array.
     * 
     * @param pObjObjArr
     * @param pString
     * @return
     */
    public static String createLayout(
            final Object[] pObjObjArr, 
            final int pStartLineOffset,
            final int pLineOffset,
            final String pRightBorderStr,
            final boolean pJoinBidirectionalLinks )
    {
        final AssignmentMatrix matrix = new AssignmentMatrix();

        /*
         * Die Nodes anlegen
         */
        for (int i = 0; i < pObjObjArr.length; i++)
        {
            final Object lineObj = pObjObjArr[i];
            
            final String nodeName = (String) ( (Object[]) lineObj )[ 0 ];

            matrix.add(
                new AssignmentMatrixNode(
                        nodeName,
                        pStartLineOffset + ( i * pLineOffset ) ) );
        }
        /*
         * Die Nodes verknpfen
         */
        for (int i = 0; i < pObjObjArr.length; i++)
        {
            final Object lineObj = pObjObjArr[i];
            
            final String nodeName = (String) ( (Object[]) lineObj )[ 0 ];
            final AssignmentMatrixNode node = matrix.getNodeForName( nodeName );

            final String[] refNodeNameArr = (String[]) ( (Object[]) lineObj )[ 1 ];
            
            for (int j = 0; j < refNodeNameArr.length; j++)
            {
                final String refNodeName = refNodeNameArr[j];
                final AssignmentMatrixNode refNode = matrix.getNodeForName( refNodeName );
                
                if ( refNode == null )
                {
                    throw new IllegalArgumentException( "Node Name existiert nicht: " + refNodeName );
                }
                
                node.addReferenceTo(
                        refNode);
            }
        }
        
        return createLayout( 
                matrix, 
                pRightBorderStr,
                pJoinBidirectionalLinks );
    }

    /**
     * Create Layout as ASCII art.
     * 
     * @param pMatrix
     * @return
     */
    public static String createLayout(
            final AssignmentMatrix pMatrix ,
            final String pRightBorderStr ,
            final boolean pJoinBidirectionalLinks )
    {
        final int maxLine = pMatrix.getMaxLine();
        
        /*
         * Ermitteln der maximmal erforderlichen vertikalen Bahnen 
         * fr die Verbindungs-Linien
         * 
         * TODO alternativ kann jedes AssignmentMatrixConnectionVO-Objekt einen Member mit der Lane-Nummer tragen, dann ist diese Map nicht mehr ntig
         */
        final IntToIntHashMap connNrToLaneNrMap =
            new IntToIntHashMap();
        
        final LayoutMatrix layoutMatrix = 
            new LayoutMatrix( maxLine + 1 );
        
        final int laneCount = 
            Math.max( 1, // TODO den Layouter null.sicher machen
            getMaxOverlapCount( 
                    pMatrix,
                    layoutMatrix,
                    connNrToLaneNrMap,
                    pJoinBidirectionalLinks ) );

        final int connMatrixWidth =
            ( laneCount
                    * LINE_SPACE );

        /*
         * Ausgabe auf ein ASCII-Canvas (ASCII-Zeichenflche)
         */
        final AsciiCanvas canvas = 
            new AsciiCanvas( 
                    maxLine + 1,
                    connMatrixWidth );
        
        /*
         * zeilenweiser Merker, ob es eine Verbindung 
         * des Knotens auf sich selbst gibt
         */
        final boolean[] hasEqualConnArr =
            new boolean[ maxLine + 1 ];
        
        final FromToLineHelper fromToLineHelper =
            new FromToLineHelper(
                    maxLine + 1 );
        
        final Iterator matrixConnetionIterator;
        if ( pJoinBidirectionalLinks )
        {
            matrixConnetionIterator = pMatrix.getMatrixConnectionIteratorSortedByDistanceAndJoinedForBidirectionalLinks();
        }
        else
        {
            matrixConnetionIterator = pMatrix.getMatrixConnectionIteratorSortedByDistance();
        }
        /*
         * Zeichnen der Verbindungen
         * 
         * Alle Nodes der Matrix werden in einer usseren Schleife durchgegangen.
         * Fr jede Node wird eine innere Schleife ber alle Zeilen durchlaufen.
         * Es wird jede von der aktuellen Node referenzierte Node geholt.
         * Nicht mehr
         * Alle Verbindungen (Connention-VO) werden...
         * 
         * Es wird eine freie Bahn (vertikale Strecke) fr die Verbindung gesucht.
         * 
         * ber die von beiden Nodes gemeinsam berdeckte strecke 
         * wird die vertikale Verbindungs-Linie gezeichnet.
         * 
         * Anfangs- und End-Verbinder (horizontal von vertikaler 
         * Linie zu Node und umgekehrt) werden gezeichnet.
         */
        int connCount = -1;
        while ( matrixConnetionIterator.hasNext() )
        {
            connCount++;
            final AssignmentMatrixConnectionVO connVO = (AssignmentMatrixConnectionVO) matrixConnetionIterator.next();
            final int nodeLineNr = connVO.node.lineNr;
            final int referencedNodeLineNr = connVO.referencedNode.lineNr;

            if ( nodeLineNr == referencedNodeLineNr )
                // eine Verbindung auf sich selbst
            {
                drawEqualConnection(
                        canvas,
                        connVO.style,
                        nodeLineNr,
                        laneCount - 1 ,
                        connMatrixWidth );
                
                hasEqualConnArr[ nodeLineNr ] = true;
                
                continue;
            }

            final int freeVerticalLaneNr =
                connNrToLaneNrMap.get( 
                        connCount );
            
            drawVerticalLine(
                    canvas,
                    connVO.style, 
                    nodeLineNr,
                    referencedNodeLineNr,
                    freeVerticalLaneNr,
                    laneCount - 1 );
           
            if ( connVO.isBidirektional )
            {
                fromToLineHelper.add(
                        nodeLineNr , 
                        FromToLineVO.TO_LINE,
                        freeVerticalLaneNr,
                        connVO.style );
            }
            else
            {
                fromToLineHelper.add(
                        nodeLineNr , 
                        FromToLineVO.FROM_LINE,
                        freeVerticalLaneNr,
                        connVO.style );
            }

            fromToLineHelper.add(
                    referencedNodeLineNr , 
                    FromToLineVO.TO_LINE,
                    freeVerticalLaneNr,
                    connVO.style );

        }
        
        
        /*
         * Zeichnen der vermerkten to-Linien
         * TODO eigene Methode
         */
        for ( int i = 0 ; i <= maxLine ; i++ )
        {
            final FromToLineVOTreeSet lineSet = fromToLineHelper.getLineSet( i );
            if ( lineSet == null )
            {
                continue;
            }
            for (Iterator iter = lineSet.iterator(); iter.hasNext();)
            {
                final FromToLineVO fromToLineVO = (FromToLineVO) iter.next();

                if ( fromToLineVO.toOrFrom == FromToLineVO.FROM_LINE )
                {
                    drawFromConnnector(
                            canvas,
                            fromToLineVO.style, 
                            i, // referencedNodeLineNr,
                            fromToLineVO.verticalLaneNr,
                            laneCount - 1 ,
                            connMatrixWidth 
                            //layoutMatrix 
                            //hasEqualConnArr
                            );
                }
                else
                {
                    drawToConnnector(
                            canvas,
                            fromToLineVO.style, 
                            i, // referencedNodeLineNr,
                            fromToLineVO.verticalLaneNr,
                            laneCount - 1 ,
                            connMatrixWidth );
                }
            }
        }
        

        // Befllen mit den Node-Namen nur fr Develop
        for (int i = 0; i < canvas.length(); i++)
        {
            final AssignmentMatrixNode node =
                pMatrix.getNodeForLineNr( i );
            if ( node != null )
            {
                canvas.getLineBuff( i ).append( pRightBorderStr + node.name );
            }
        }

        return canvas.toString();
        
    }

    /**
     * @param pMatrix
     * @param pMaxLine
     * @return
     */
    private static int getMaxOverlapCount(
            final AssignmentMatrix pMatrix ,
            final LayoutMatrix pLayoutMatrix ,
            final IntToIntHashMap pConnNrToLaneNrMap ,
            final boolean pJoinBidirectionalLinks )
    {
        /*
         * Ermitteln der breitesten berdeckung von Verbindungen
         * 
         * Alle Nodes der Matrix werden in einer usseren Schleife durchgegangen.
         * Fr jede Node wird eine innere Schleife ber alle Zeilen durchlaufen.
         * Es wird jede von der aktuellen Node referenzierte Node geholt.
         * 
         * Die von beiden Nodes gemeinsam berdeckte Strecke von 
         * Zeilen-Zhler-Eintrgen wird inkrementiert.
         */

        final Iterator matrixConnetionIterator;
        if ( pJoinBidirectionalLinks )
        {
            matrixConnetionIterator = pMatrix.getMatrixConnectionIteratorSortedByDistanceAndJoinedForBidirectionalLinks();
        }
        else
        {
            matrixConnetionIterator = pMatrix.getMatrixConnectionIteratorSortedByDistance();
        }

        int laneCount = 0;
        int connCount = 0;
        while ( matrixConnetionIterator.hasNext() )
        {
            final AssignmentMatrixConnectionVO connVO = (AssignmentMatrixConnectionVO) matrixConnetionIterator.next();

            final int nodeLineNr = connVO.node.lineNr;
            final int referencedNodeLineNr = connVO.referencedNode.lineNr;
            
            laneCount = searchAndReserveVerticalLane(
                    pLayoutMatrix,
                    pConnNrToLaneNrMap,
                    laneCount, 
                    nodeLineNr,
                    referencedNodeLineNr,
                    connCount );
            connCount++;
        }
        return laneCount;
    }

    /**
     * 
     * @param pConnectionOverlapArrayListArr ArrayList-Array fr die jeweiligen freien/besetzten Bahnen
     * @param pFromLineNr
     * @param pToLineNr
     * @return laneCount
     */
    private static int searchAndReserveVerticalLane(
            final LayoutMatrix pLayoutMatrix, 
            final IntToIntHashMap pConnNrToLaneNrMap,
            final int pLaneCount,
            final int pFromLineNr, 
            final int pToLineNr,
            final int pConnNr )
    {
        final int fromLineNr, toLineNr;
        // Richtung beachten
        if ( pFromLineNr < pToLineNr )
        {
            fromLineNr = pFromLineNr;
            toLineNr   = pToLineNr;
        }
        else
        {
            fromLineNr = pToLineNr;
            toLineNr   = pFromLineNr;
        }
        
        // TODO gegen null und length == 0 sichern

        int freeLaneNr = 0;
        //Label zum verlassen der usseren for-Schleife
        laneNrLoop:
        while ( freeLaneNr < pLaneCount )
            // es sollte immer eine freie Bahn gefunden werden
        {
            for (int i = fromLineNr; i < toLineNr + 1; i++)
            {
                final int laneConnNr = 
                    pLayoutMatrix.get( 
                            i ,
                        //freeLaneChrPos 
                        freeLaneNr 
                        );
                
                if ( laneConnNr >= 0 )
                    // Bahn ist besetzt
                {
                    // nchste Bahn versuchen
                    freeLaneNr++;
                    continue laneNrLoop;
                }
            }
            // gefundene freie Bahn reservieren
            reserveVerticalLane(
                    pLayoutMatrix, 
                    pFromLineNr, 
                    pToLineNr, 
                    freeLaneNr,
                    pConnNr );

            pConnNrToLaneNrMap.put( pConnNr, freeLaneNr );
            
            // keine Erhhung der Bahn-Anzahl
            return pLaneCount;
        }
        // keine freie Bahn vorhanden, eine neue Bahn ziehen

        // neue Bahn reservieren
        reserveVerticalLane(
                pLayoutMatrix, 
                pFromLineNr, 
                pToLineNr, 
                freeLaneNr,
                pConnNr );

        pConnNrToLaneNrMap.put( pConnNr, freeLaneNr );
        
        //Erhhung der Bahn-Anzahl
        return freeLaneNr + 1;
    }
    /**
     * @param pConnectionOverlapArrayListArr
     * @param pFromLineNr
     * @param pToLineNr
     * @param pLaneNr
     */
    private static void reserveVerticalLane(
            final LayoutMatrix pLayoutMatrix, 
            final int pFromLineNr, 
            final int pToLineNr, 
            final int pLaneNr,
            final int pConnNr )
    {
        final int fromLineNr, toLineNr;
        // Richtung beachten
        if ( pFromLineNr < pToLineNr )
        {
            fromLineNr = pFromLineNr;
            toLineNr   = pToLineNr;
        }
        else
        {
            fromLineNr = pToLineNr;
            toLineNr   = pFromLineNr;
        }

        for (int i = 0; i < pLayoutMatrix.length(); i++)
        {
            if ( i >= fromLineNr && i <= toLineNr )
            {
                pLayoutMatrix.set(
                        i ,
                        pLaneNr , 
                        pConnNr );
            }
        }
//System.out.println("-----------------------------------------------------------------------------------");        
    }
    
    /**
     * draw vertical line.
     * 
     * @param pLineStrArr
     * @param pNodeLineNr
     * @param pReferencedNodeLineNr
     * @param pVerticalLaneNr
     */
    private static void drawVerticalLine(
            final AsciiCanvas pCanvas, 
            final AssignmentMatrixConnectionStyle pStyle,
            final int pFromLineNr, 
            final int pToLineNr,
            final int pVerticalLaneNr,
            final int pMaxLaneNr )
    {
        final int laneChrPos = computeVerticalLaneChrPos(pVerticalLaneNr, pMaxLaneNr);

        final int fromLineNr, toLineNr;
        // Richtung beachten
        if ( pFromLineNr < pToLineNr )
        {
            fromLineNr = pFromLineNr;
            toLineNr   = pToLineNr;
        }
        else
        {
            fromLineNr = pToLineNr;
            toLineNr   = pFromLineNr;
        }
        //pCanvas.setCharAt( fromLineNr, laneChrPos, '+' );
        pCanvas.setCharAt( fromLineNr, laneChrPos, pStyle.getTopCornerChr() );
        for ( int i = fromLineNr + 1 ; i < toLineNr ; i++ )
        {
            //pCanvas.setCharAt( i, laneChrPos, '|' );
            pCanvas.setCharAt( i, laneChrPos, pStyle.getVerticalChr() );
        }
        //pCanvas.setCharAt( toLineNr, laneChrPos, '+' );
        pCanvas.setCharAt( toLineNr, laneChrPos, pStyle.getBottomCornerChr() );
    }

    /**
     * Berechne die Spalten-Position des Zeichens
     * fr den vertikalen Strich in der spezifizierten
     * Bahn.
     * 
     * @param pVerticalLaneNr Index der Bahn von rechts beginnend
     * @param pMaxLaneNr      maximaler Bahn-Index
     * @return                Spalten-Position
     */
    private static int computeVerticalLaneChrPos(
            final int pVerticalLaneNr, 
            final int pMaxLaneNr)
    {
        return ( ( pMaxLaneNr - pVerticalLaneNr ) * LINE_SPACE );
    }

    /**
     * draw 'from' connector. 
     * 
     * @param pLineStrArr
     * @param pNodeLineNr
     * @param pReferencedNodeLineNr
     * @param pVerticalLaneNr
     */
    private static void drawFromConnnector(
            final AsciiCanvas pCanvas, 
            final AssignmentMatrixConnectionStyle pStyle,
            final int pFromLineNr, 
            final int pVerticalLaneNr,
            final int pMaxLaneNr,
            final int pMaxWidth
            //final LayoutMatrix pLayoutMatrix 
            )
    {
        final int laneChrPos = computeVerticalLaneChrPos(pVerticalLaneNr, pMaxLaneNr);

        for ( int i = laneChrPos + 1 ; i < pMaxWidth ; i++ )
        {
            final char oldChar = pCanvas.charAt( pFromLineNr, i );
            
            if ( oldChar == ' ' )
                // wenn Zeichen-Position nicht belegt ist
                // nicht ber die vorhandene Linie zeichnen
            {
                pCanvas.setCharAt( pFromLineNr, i, pStyle.getFromNodeLineChr() );
            }
        }
    }

    /**
     * draw 'to' connector. 
     * 
     * @param pLineStrArr
     * @param pNodeLineNr
     * @param pReferencedNodeLineNr
     * @param pVerticalLaneNr
     */
    private static void drawToConnnector(
            final AsciiCanvas pCanvas, 
            final AssignmentMatrixConnectionStyle pStyle,
            final int pToLineNr,
            final int pVerticalLaneNr,
            final int pMaxLaneNr,
            final int pMaxWidth )
    {
        final int laneChrPos = computeVerticalLaneChrPos(pVerticalLaneNr, pMaxLaneNr);

        for ( int i = laneChrPos + 1 ; i < pMaxWidth - 1 ; i++ )
        {
            final char oldChar = pCanvas.charAt( pToLineNr, i );
            if ( oldChar == ' ' )
                // wenn Zeichen-Position nicht belegt ist
                // nicht ber die vorhandene Linie zeichnen
            {
                pCanvas.setCharAt( pToLineNr, i, pStyle.getToNodeLineChr() );
            }
            else if ( i < pMaxWidth - 1 //--
                    && pCanvas.charAt( pToLineNr, i + 1 ) == ' ' )
                // es kommt wieder eine freie Stelle
                // vertikale Linie berspringen
            {
                continue;
            }
            else
                // Zeichnen der from-Linie abbrechen
            {
                if ( i == laneChrPos + 1 )
                    // i wurde niemals erhht
                {
                    throw new RuntimeException( "Pfeil falsch " + i );
                }
                // Pfeil an voriger Position zeichnen
                pCanvas.setCharAt( pToLineNr, i - 1, '>'/*'1'*/ );
                // Zeichnen Abbrechen
                return;
            }
        }
        pCanvas.setCharAt( pToLineNr, pMaxWidth - 1, '>'/*'2'*/ );
    }

    /**
     * Helper-Klasse zum Vermerken der zu 
     * zeichnenden Verbindungen auf den 
     * jeweiligen Character-Positionen im
     * Zeichenbereich.
     * 
     * Der Zeichenbereich wird rechteckig in
     * Zeilen und Spalten aufgeteilt und
     * fr jede Postion die darauf verlaufende
     * Verbindung als Nummer vermerkt.
     */
    static class LayoutMatrix
    {
        final ArrayList[] lineListArr;

        /**
         * Constructor.
         *
         * @param pLineCount
         */
        public LayoutMatrix(
                final int pLineCount )
        {
            this.lineListArr = new ArrayList[ pLineCount ];
            for (int i = 0; i < this.lineListArr.length; i++)
            {
                this.lineListArr[ i ] = new ArrayList();
            }
        }
        
        /**
         * TODO schneller machen, nicht jedesmal neu ermitteln
         */
        public boolean horizontalWegVersperrtAb(
                final int pLineNr, 
                final int pColumnNr )
        {
            if ( pColumnNr >= this.width() )
                // ganz rechts angekommen
            {
                return true;
            }
            final ArrayList lineList = this.lineListArr[ pLineNr ];

            final Integer connNrObj = (Integer) lineList.get( pColumnNr );
            if ( connNrObj == null )
                // Platz ist frei
            {
                return false;
            }
                
            /*
             * Bestimmen, ob der aktuelle Platz eine
             * Abbiegung von oder zum Knoten ist.
             */
            if ( pLineNr == 0 || pLineNr == this.length() - 1 )
                // oberste oder unterste Zeile, hier muss die Linie immer abbiegen
            {
               return true; 
            }

            final int connNr = connNrObj.intValue();

            if ( connNr != get( pLineNr - 1 , pColumnNr ) )
            {
                return true; 
            }
            if ( connNr != get( pLineNr + 1 , pColumnNr ) )
            {
                return true; 
            }

            return false;
        }

        /**
         * Anzahl Zeilen.
         * 
         * @return
         */
        int length()
        {
            return this.lineListArr.length;
        }

        /**
         * Anzahl Spalten.
         * 
         * @return
         */
        int width()
        {
            if ( this.lineListArr.length < 1 )
            {
                return 0;
            }
            return this.lineListArr[ 0 ].size();
        }

        /**
         * Get connection number for given line
         * number and column number.
         * 
         * @param pLineNr
         * @param pColumnNr
         * @return
         */
        int get(
                final int pLineNr, 
                final int pColumnNr )
        {
            final ArrayList lineList = this.lineListArr[ pLineNr ];
            if ( lineList.size() <= pColumnNr )
            {
                return Integer.MIN_VALUE;
            }
            final Integer posIntObj = (Integer) lineList.get( pColumnNr );
            if ( posIntObj == null )
            {
                return Integer.MIN_VALUE;
            }
            return posIntObj.intValue();
        }
        
        /**
         * Set connection number for given line
         * number and column number.
         * 
         * @param pLineNr
         * @param pColumnNr
         * @param pConnectionNr
         */
        void set(
                final int pLineNr , 
                final int pColumnNr ,
                final int pConnectionNr )
        {
            final ArrayList lineList = this.lineListArr[ pLineNr ];
            if ( lineList.size() <= pColumnNr )
            {
                // Vergrssere Alle Zeilen
                resize( pColumnNr + 1 );
            }
            CollectionUtil.set(
                    lineList,
                    pColumnNr , 
                    new Integer( pConnectionNr ) );
        }

        /**
         * debug output.
         * @return
         */
        public String toString()
        {
            final UnSynchStringBuffer strBuff = new UnSynchStringBuffer( this.length() * ( ( ( this.width() + 1 ) * 4 ) + 1 ) );
            for ( int i = 0 ; i < this.lineListArr.length ; i++ )
            {
                strBuff.append( StringUtil.strzero( i , 3 ) + ':' );
                final ArrayList lineList = this.lineListArr[ i ];
                for (int j = 0; j < lineList.size(); j++)
                {
                    strBuff.append( ( lineList.get( j ) == null ? "   " :  StringUtil.strzero( ( (Integer) lineList.get( j ) ).intValue() , 3 ) ) + " " );
                }
                strBuff.append( '\n' );
            }
            return strBuff.toString();
        }
        
        /**
         * Vergssern aller Zeilen.
         * 
         * @param pSize 
         */
        private void resize(
                final int pSize )
        {
            for (int i = 0; i < this.lineListArr.length; i++)
            {
                CollectionUtil.resize(
                        this.lineListArr[ i ],
                        pSize );
            }
        }
    }
    
    /**
     * Hilfs-Klasse zum Vermerken der als Letztes
     * zu ziehenden Linien von der vertikalen
     * Linie zum Ziel-Knoten.
     */
    static class FromToLineHelper
    {
        /**
         * Fr jede Zeile eine sortierte
         * Menge von Verbindungen zum
         * Ziel-Knoten
         */
        private final FromToLineVOTreeSet[] toLineSetArr;

        /**
         * Constructor.
         *
         * @param pLineCount
         */
        FromToLineHelper(
                final int pLineCount )
        {
            this.toLineSetArr = new FromToLineVOTreeSet[ pLineCount ];
        }

        /**
         * Add line to Node.
         * 
         * @param pLineNr
         * @param pVerticalLaneNr
         */
        void add(
                final int pLineNr, 
                final int pToOrFrom, 
                final int pVerticalLaneNr, 
                final AssignmentMatrixConnectionStyle pStyle )
        {
            if ( this.toLineSetArr[ pLineNr] == null )
            {
                this.toLineSetArr[ pLineNr ] = new FromToLineVOTreeSet( 
                        //Collections.reverseOrder() 
                        );
            }
            this.toLineSetArr[ pLineNr ].add( 
                    new FromToLineVO( 
                            pToOrFrom,
                            pVerticalLaneNr,
                            pStyle ) );
        }
        
        /**
         * @param pLineNr
         * @return
         */
        public FromToLineVOTreeSet getLineSet(
                final int pLineNr )
        {
            return this.toLineSetArr[ pLineNr ];
        }
    }
    
    /**
     * @param pNodeLineNr
     */
    private static void drawEqualConnection(
            final AsciiCanvas pCanvas, 
            final AssignmentMatrixConnectionStyle pStyle,
            final int pNodeLineNr,
            final int pMaxLaneNr,
            final int pMaxWidth )
    {
        final int laneChrPos = computeVerticalLaneChrPos( 
                0 , // equal Connections (Verbindung Knoten mit sich selbst) liegen immer auf der Lane 0
                pMaxLaneNr );

        pCanvas.setCharAt( pNodeLineNr, laneChrPos + 1, pStyle.getEqualVerticalChr() );
        for ( int i = laneChrPos + 2 ; i < pMaxWidth ; i++ )
        {
            pCanvas.setCharAt( pNodeLineNr, i, pStyle.getEqualFromToNodeLineChr() );
        }
    }
}
