/**
 * 
 */
package assignment_matrix_layouter;

/**
 * @author Heiner Kcker
 *
 */
public class FromToLineVO
implements Comparable
{
    static final int TO_LINE = 0;
    
    static final int FROM_LINE = 1;

    /**
     * Richtung zum Konten oder vom Knoten
     */
    final int toOrFrom;
    
    /**
     * vertikale Bahn
     */
    final int verticalLaneNr;
    
    /**
     * Linien-Art
     */
    final AssignmentMatrixConnectionStyle style;

    /**
     * Constructor.
     *
     * @param pToOrFrom
     * @param pVerticalLaneNr
     * @param pStyle
     */
    FromToLineVO(
            final int pToOrFrom, 
            final int pVerticalLaneNr, 
            final AssignmentMatrixConnectionStyle pStyle )
    {
        super();
        this.toOrFrom = pToOrFrom;
        this.verticalLaneNr = pVerticalLaneNr;
        this.style = pStyle;
    }

    /* (non-Javadoc)
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo(
            final Object pObj )
    {
        final FromToLineVO other = (FromToLineVO) pObj;
        int retVal = this.verticalLaneNr - other.verticalLaneNr;
        if ( retVal != 0 )
        {
            return retVal;
        }
        return this.toOrFrom - other.toOrFrom;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    public int hashCode()
    {
        final int PRIME = 31;
        int result = 1;
        result = PRIME * result + ((this.style == null) ? 0 : this.style.hashCode());
        result = PRIME * result + this.toOrFrom;
        result = PRIME * result + this.verticalLaneNr;
        return result;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object obj)
    {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final FromToLineVO other = (FromToLineVO) obj;
        if (this.style == null)
        {
            if (other.style != null)
                return false;
        }
        else if (!this.style.equals(other.style))
            return false;
        if (this.toOrFrom != other.toOrFrom)
            return false;
        if (this.verticalLaneNr != other.verticalLaneNr)
            return false;
        return true;
    }

}
