package assignment_matrix_layouter;

import java.util.*;

/**
 * Generated FromToLineVOTreeSet class.
 * This class wraps an untyped TreeSet
 * to an typed FromToLineVOTreeSet
 * for type safe implementation.
 */
public class FromToLineVOTreeSet
{
    /**
     * Dieses Set wird typisiert.
     */
    final TreeSet innerSet;

    /**
     * Constructor.
     *
     * @param pInnerSet
     */
    public FromToLineVOTreeSet(
            final Collection pCollection)
    {
        this.innerSet = new TreeSet( pCollection );
    }

    /**
     * Constructor.
     */
    public FromToLineVOTreeSet()
    {
        super();
        this.innerSet = new TreeSet();
    }

    /**
     * Constructor.
     *
     * @param pComparator
     */
    public FromToLineVOTreeSet(
            final Comparator pComparator ) 
    {
        this.innerSet = new TreeSet( pComparator );
    }

    /**
     * @param pObj
     * @return
     * @see java.util.Set#add(java.lang.Object)
     */
    public boolean add(
            final FromToLineVO pObj)
    {
        return this.innerSet.add(pObj);
    }

    /**
     * @param pFromToLineVOTreeSet
     * @return
     * @see java.util.AbstractCollection#addAll(java.util.Collection)
     */
    public boolean addAll(
            final FromToLineVOTreeSet pFromToLineVOTreeSet)
    {
        return this.innerSet.addAll( pFromToLineVOTreeSet.innerSet );
    }

    /**
     * 
     * @see java.util.Set#clear()
     */
    public void clear()
    {
        this.innerSet.clear();
    }

    /**
     * @return
     * @see java.util.Set#clone()
     */
    public Object clone()
    {
        return new FromToLineVOTreeSet( this.innerSet );
    }

    /**
     * @param pObj
     * @return
     * @see java.util.Set#contains(java.lang.Object)
     */
    public boolean contains(
            final FromToLineVO pObj)
    {
        return this.innerSet.contains(pObj);
    }

    /**
     * @param pCollection
     * @return
     * @see java.util.AbstractCollection#containsAll(java.util.Collection)
     */
    public boolean containsAll(
            final Collection pCollection)
    {
        return this.innerSet.containsAll(pCollection);
    }

    /**
     * @param pFromToLineVOTreeSet
     * @return
     * @see java.util.AbstractCollection#containsAll(java.util.Collection)
     */
    public boolean containsAll(
            final FromToLineVOTreeSet pFromToLineVOTreeSet)
    {
        return this.innerSet.containsAll( pFromToLineVOTreeSet.innerSet );
    }

    /**
     * @param pObj
     * @return
     * @see java.util.AbstractSet#equals(java.lang.Object)
     */
    public boolean equals(
            final Object pObj)
    {
        if ( pObj instanceof FromToLineVOTreeSet )
        {
            final FromToLineVOTreeSet otherSet = (FromToLineVOTreeSet) pObj;
            return this.innerSet.equals( otherSet.innerSet );
        }
        return false;
    }

    /**
     * @return
     * @see java.util.AbstractSet#hashCode()
     */
    public int hashCode()
    {
        return this.innerSet.hashCode();
    }

    /**
     * @return
     * @see java.util.Set#isEmpty()
     */
    public boolean isEmpty()
    {
        return this.innerSet.isEmpty();
    }

    /**
     * @return
     * @see java.util.Set#iterator()
     */
    public Iterator iterator()
    {
        return this.innerSet.iterator();
    }

    /**
     * @param pObj
     * @return
     * @see java.util.Set#remove(java.lang.Object)
     */
    public boolean remove(
            final FromToLineVO pObj)
    {
        return this.innerSet.remove(pObj);
    }

    /**
     * @param pCollection
     * @return
     * @see java.util.AbstractSet#removeAll(java.util.Collection)
     */
    public boolean removeAll(
            final FromToLineVOTreeSet pFromToLineVOTreeSet)
    {
        return this.innerSet.removeAll( pFromToLineVOTreeSet.innerSet );
    }

    /**
     * @param pCollection
     * @return
     * @see java.util.AbstractSet#removeAll(java.util.Collection)
     */
    public boolean removeAll(
            final Collection pCollection)
    {
        return this.innerSet.removeAll(pCollection);
    }

    /**
     * @param pFromToLineVOTreeSet
     * @return
     * @see java.util.AbstractCollection#retainAll(java.util.Collection)
     */
    public boolean retainAll(
            final FromToLineVOTreeSet pFromToLineVOTreeSet)
    {
        return this.innerSet.retainAll( pFromToLineVOTreeSet.innerSet );
    }

    /**
     * @param pFromToLineVOTreeSet
     * @return
     * @see java.util.AbstractCollection#retainAll(java.util.Collection)
     */
    public boolean retainAll(
            final Collection pCollection )
    {
        return this.innerSet.retainAll( pCollection );
    }

    /**
     * @return
     * @see java.util.Set#size()
     */
    public int size()
    {
        return this.innerSet.size();
    }

    /**
     * @return
     * @see java.util.AbstractCollection#toArray()
     */
    public FromToLineVO[] toArray()
    {
        return (FromToLineVO[]) this.innerSet.toArray( new FromToLineVO[ this.innerSet.size() ] );
    }

    /**
     * @param pArr
     * @return
     * @see java.util.AbstractCollection#toArray(java.lang.Object[])
     */
    public FromToLineVO[] toArray(
            final FromToLineVO[] pArr)
    {
        return (FromToLineVO[]) this.innerSet.toArray(pArr);
    }

    /**
     * @return
     * @see java.util.AbstractCollection#toString()
     */
    public String toString()
    {
        return this.innerSet.toString();
    }

    /**
     * This method returns an clone
     * of the wrapped set object
     * to implement the {@link java.util.Set} interface.
     */
    public Set toSet()
    {
        return new TreeSet( this.innerSet ) ;
    }
}
